<?php
/*======================================================================*\
|| #################################################################### ||
|| # Set Default Thread Order for Forums  1.1 PL1
|| # Build: 9
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2012 Daniel Fatkic aka ragtek. All Rights Reserved.   # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # http://www.ragtek.org                                            # ||
|| #################################################################### ||
\*======================================================================*/


class Ragtek_TO_ControllerAdmin_Forum extends
    XFCP_Ragtek_TO_ControllerAdmin_Forum
{

    public function actionEdit()
	{
        $return = parent::actionEdit();
        return $this->_addSortOptions($return);
    }

    public function actionSave(){
        $response = parent::actionSave();
        if ($response->redirectType == XenForo_ControllerResponse_Redirect::SUCCESS && $node = XenForo_Application::get(Ragtek_TO_DW_Forum::RAGTEK_FORUM_REGISTRY_KEY));
        {
            $writerData = $this->_input->filter(array(

                'ragtek_sort_options' => XenForo_Input::STRING,
                'ragtek_sort_order_dir' => XenForo_Input::STRING,
                'ragtek_custom_sort' => XenForo_Input::UINT
            ));
            /** @var $writer XenForo_DataWriter_Forum */
            $writer = $this->_getNodeDataWriter();
            $writer->setExistingData($node);

            if ($writerData['ragtek_custom_sort']){
                $writer->bulkSet($writerData);
            }
            else {
               $writer->set('ragtek_custom_sort', 0);
            }
            $writer->save();

        }
        return $response;
    }

    protected function _addSortOptions($return){
        $return->params['ragtek_sort_options'] = array('title' => new XenForo_Phrase('title_alphabetical'), 'post_date' => new XenForo_Phrase('thread_creation_time'), 'reply_count'=> new XenForo_Phrase('number_of_replies'), 'view_count' => new XenForo_Phrase('number_of_views'), 'last_post_date' =>  new XenForo_Phrase('last_message_time'));
        $return->params['ragtek_sortOrder'] = array('DESC'=>new XenForo_Phrase('descending_order'), 'ASC' => new XenForo_Phrase('ascending_order'));
        return $return;
    }
}