<?php
/*======================================================================*\
|| #################################################################### ||
|| # Set Default Thread Order for Forums  1.1 PL1
|| # Build: 9
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2012 Daniel Fatkic aka ragtek. All Rights Reserved.   # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # http://www.ragtek.org                                            # ||
|| #################################################################### ||
\*======================================================================*/


class Ragtek_TO_Install
{

    protected $_queries = array();

    public function _installVersion6()
    {

        if (!self::checkIfExist('xf_forum', 'ragtek_custom_sort')) {
            $this->_queries['ragtek_custom_sort'] = "
                ALTER TABLE  xf_forum
                ADD  `ragtek_custom_sort` TINYINT UNSIGNED NOT NULL DEFAULT 0
            ";
        }

        if (!self::checkIfExist('xf_forum', 'ragtek_sort_options')) {
            $this->_queries['ragtek_sort_options'] = "
              ALTER TABLE  xf_forum
              ADD  `ragtek_sort_options` ENUM(  'title',  'post_date',  'reply_count',  'view_count',  'last_post_date' ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT  'post_date'
            ";
        }

        if (!self::checkIfExist('xf_forum', 'ragtek_sort_order_dir')) {

            $this->_queries['ragtek_sort_order_dir'] = "
              ALTER TABLE  xf_forum
              ADD  `ragtek_sort_order_dir` ENUM(  'ASC',  'DESC') CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT  'DESC'
            ";
        }

        if (count( $this->_queries) > 0) {
            $this->_runQuery( $this->_queries);
        }

    }


    public static function install($existingAddOn, $addOnData)
    {
        $startVersionId = 1;
        $endVersionId = $addOnData['version_id'];

        if ($existingAddOn) {
            $startVersionId = $existingAddOn['version_id'] + 1;
        }
        $install = self::getInstance();

        for ($i = $startVersionId; $i <= $endVersionId; $i++) {
            $method = '_installVersion' . $i;
            if (method_exists($install, $method) === false) {
                continue;
            }
            $install->$method();
        }
    }

    public static function _runQuery(array $queries)
    {
        $db = XenForo_Application::getDb();
        foreach ($queries AS $id => $query) {
            $db->query($query);
        }
    }


    static private $instance = null;

    public static function getInstance()
    {

        if (self::$instance == null) {
            self::$instance = new self();
        }
        return self::$instance;
    }


    public static function uninstall()
    {
        $query['uninstall_1'] = "
            ALTER TABLE  xf_forum DROP COLUMN ragtek_sort_options
        ";

        $query['uninstall_2'] = "
           ALTER TABLE  xf_forum DROP COLUMN ragtek_sort_order_dir
        ";

        $query['uninstall_3'] = "
           ALTER TABLE xf_forum DROP  COLUMN ragtek_custom_sort
        ";

        self::_runQuery($query);
    }

    public static function checkIfExist($table, $field)
    {
        $db = XenForo_Application::get('db');
        if ($db->fetchRow('SHOW columns FROM `' . $table . '` WHERE Field = ?', $field)) {
            return true;
        }
        else {
            return false;
        }
    }
}